wok annotate syslinux/stuff/iso2exe/init @ rev 21459

ttf-dejavu*: update web_site
author Pascal Bellard <pascal.bellard@slitaz.org>
date Tue Apr 30 09:31:34 2019 +0200 (6 months ago)
parents cacdb1fe56bc
children 0ef373cebc01
rev   line source
pascal@21302 1 #!/bin/sh
pascal@13691 2
pascal@13691 3 DIALOG=dialog
pascal@13691 4
pascal@17454 5 ddq()
pascal@17454 6 {
pascal@17454 7 dd $@ 2> /dev/null
pascal@17454 8 }
pascal@17454 9
pascal@13691 10 get()
pascal@13691 11 {
pascal@17496 12 od -v -j $1 -N ${4:-${3:-2}} -t u${3:-2} -w${3:-2} -An $2 2>/dev/null ||
pascal@17496 13 hexdump -v -s $1 -n ${4:-${3:-2}} -e "\"\" 1/${3:-2} \" %d\n\"" $2
pascal@13691 14 }
pascal@13691 15
pascal@13691 16 getarg()
pascal@13691 17 {
pascal@13691 18 sed "/$1=/!d;s/.*$1=\\([^ ]*\\).*/\\1/" /proc/cmdline
pascal@13691 19 }
pascal@13691 20
pascal@17489 21 clear()
pascal@17489 22 {
pascal@17489 23 echo -e "\x1B[1;1H\x1B[J"
pascal@17489 24 }
pascal@17489 25
pascal@17569 26 xless()
pascal@17569 27 {
pascal@17569 28 [ $(wc -l < "$1") -gt 22 ] &&
pascal@17569 29 sed 's/..3.;4.m/===/g;$s/.*/&\n---\nPress q to continue/' "$1" | less ||
pascal@17569 30 { cat "$1"
pascal@17569 31 [ "$2" ] || return
pascal@17569 32 echo -e "$2"
pascal@17569 33 read n
pascal@17569 34 }
pascal@17569 35 }
pascal@17569 36
pascal@17489 37 tinydialog()
pascal@17489 38 {
pascal@17489 39 clear
pascal@17489 40 label=""
pascal@17489 41 while [ "$1" ]; do
pascal@17489 42 case "$1" in
pascal@17489 43 --title) title=" \x1B[30;47m$2\x1B[37;40m\n"
pascal@17489 44 echo -e $title; shift ;;
pascal@17489 45 --yes-label) label="$2" ; shift ;;
pascal@17489 46 --textbox)
pascal@17569 47 xless "$2" "\nPress RETURN to continue."
pascal@17489 48 break;;
pascal@17489 49 --gauge)
pascal@17489 50 t=" "
pascal@17489 51 echo -e "$t$2\n"
pascal@17489 52 while read pct ; do
pascal@17489 53 s=" "
pascal@17489 54 s="$s$pct%$s"
pascal@17489 55 pct=$((($pct*63)/100))
pascal@17489 56 echo -en "\r$t\x1B[30;47m$(echo "$s" | cut -c-$pct)\x1B[37;40m$(echo "$s" | cut -c$(($pct+1))-)"
pascal@17489 57 done
pascal@17489 58 break;;
pascal@17489 59 --yesno)
pascal@17489 60 while true; do
pascal@17489 61 clear
pascal@17491 62 echo "$2" | sed 's/\\n\\n/\\n/g;s/\\n/\n/g'
pascal@17491 63 echo -en " <- 1:${label:-Yes} 2:Cancel\r"
pascal@17489 64 read x
pascal@17489 65 case "$x" in
pascal@17489 66 ''|Y*|y*|1) return 0;;
pascal@17489 67 N*|n*|2|0) return 1;;
pascal@17489 68 esac
pascal@17489 69 done ;;
pascal@17489 70 --menu|--radiolist)
pascal@20891 71 [ "$1" = "--menu" ] && shft=2 || shft=3
pascal@17491 72 label=""
pascal@20771 73 [ "$2" ] && label="\n$2"
pascal@17489 74 shift 5
pascal@17491 75 echo -e "$title$label\n0 Cancel" > /tmp/data
pascal@17489 76 n=1
pascal@17489 77 while [ "$1" ]; do
pascal@17489 78 eval key_$n='$1'
pascal@17489 79 echo "$((n++)) $2"
pascal@17491 80 shift $shft
pascal@17489 81 done >> /tmp/data
pascal@17489 82 while ! grep -q "^$n " /tmp/data ; do
pascal@17489 83 clear
pascal@17569 84 xless /tmp/data
pascal@17489 85 echo -en "\n <- Enter the selection number\r"
pascal@17489 86 read n
pascal@17489 87 done 2> /dev/null
pascal@17489 88 rm -f /tmp/data
pascal@17489 89 [ $n -eq 0 ] && return 1
pascal@17489 90 eval echo -n \$key_$n 1>&2
pascal@17489 91 return 0;;
pascal@17489 92 esac
pascal@17489 93 shift
pascal@17489 94 done
pascal@17489 95 }
pascal@17489 96
pascal@16041 97 mount_proc()
pascal@16041 98 {
pascal@16041 99 mount -t proc /proc /proc
pascal@16041 100 mount -t sysfs /sys /sys
pascal@16041 101 udevd --daemon 2> /dev/null && udevadm trigger && sleep 5
pascal@16041 102 }
pascal@16041 103
pascal@16041 104 umount_proc()
pascal@16041 105 {
pascal@16041 106 killall udevd 2> /dev/null
pascal@16041 107 umount /sys/fs/fuse/connections 2> /dev/null
pascal@16041 108 umount /sys
pascal@16041 109 umount /proc
pascal@16041 110 }
pascal@16041 111
pascal@17473 112 bytes2bin()
pascal@17473 113 {
pascal@17473 114 for i in $@ ; do
pascal@17569 115 printf '\\\\x%02X' $(($i&255))
pascal@17569 116 done | xargs echo -en
pascal@17473 117 }
pascal@17473 118
pascal@17454 119 words2bin()
pascal@17454 120 {
pascal@17454 121 for i in $@ ; do
pascal@17569 122 printf '\\\\x%02X\\\\x%02X' $(($i&255)) $((($i>>8)&255))
pascal@17569 123 done | xargs echo -en
pascal@17454 124 }
pascal@17454 125
pascal@13691 126 gettazboot()
pascal@13691 127 {
paul@13692 128 echo "Creating $(basename $1) ..."
pascal@17810 129 O=$(($(get 64 /mnt/$ISO) - 0xC0))
pascal@17492 130 L=$(($(get 20 /mnt/$ISO) - 0xC0 - $(get 24 /mnt/$ISO) - $O))
pascal@13691 131 S=$((32+$L))
pascal@13691 132 P=$((($S+511)/512))
pascal@13691 133 E=$((4096-(32*$P)))
pascal@17454 134 words2bin 0x5A4D $(($S%512)) $P 0 2 $E -1 $((${2:-0}-16)) \
pascal@17454 135 -2 0 256 -16 28 0x6C53 0x5469 0x7A61 > $1
pascal@17454 136 ddq bs=1 count=$L skip=$(echo $O) if=/mnt/$ISO >> $1
pascal@13691 137 }
pascal@13691 138
pascal@13691 139 checkmagic()
pascal@13691 140 {
pascal@20891 141 [ -s $1 ] && [ $(getarg magic) = $(get 18 $1 2) ]
pascal@13691 142 }
pascal@13691 143
pascal@13691 144 getiso()
pascal@13691 145 {
pascal@13713 146 mkdir -p /media/cdrom
pascal@17489 147 for dev in /sys/block/?d?/?d??* ; do
pascal@17489 148 mount /dev/$(basename $dev) /mnt
pascal@13713 149 if checkmagic /mnt/$ISO; then
pascal@13713 150 mount -o loop,ro /mnt/$ISO /media/cdrom
pascal@17489 151 echo "Found $ISO on $(basename $dev)"
pascal@19510 152 return 0
pascal@13713 153 fi
pascal@13713 154 umount /mnt
pascal@19510 155 done 2> /dev/null
pascal@19510 156 return 1
pascal@13691 157 }
pascal@13691 158
pascal@13691 159 uncpio()
pascal@13691 160 {
pascal@17489 161 [ -s "$1" ] || return
pascal@17476 162 echo -en "\n Extracting $(basename $1) ..."
pascal@13699 163 case $(get 0 $1) in
pascal@17160 164 *35615) ( zcat || gunzip ) ;;
pascal@17476 165 *14333) unxz ;;
pascal@17160 166 *\ 93) unlzma ;;
pascal@17160 167 *) cat ;;
pascal@17160 168 esac < $1 | ( cd ${2:-/} ; cpio -idmu > /dev/null 2>&1 )
pascal@13691 169 }
pascal@13691 170
pascal@17476 171 dotwait()
pascal@17476 172 {
pascal@17476 173 echo -n "${1:-Install filesystem}.."
pascal@21363 174 echo -n > /tmp/wait
pascal@17476 175 while [ -e /tmp/wait ]; do
pascal@17476 176 echo -n "." > /dev/tty0
pascal@17476 177 sleep 1
pascal@17476 178 done &
pascal@17476 179 }
pascal@17476 180
pascal@13691 181 getuuid()
pascal@13691 182 {
pascal@13691 183 dev=$(mount | sed '/ \/mnt /!d;s/ .*//;s|/dev/||;q')
pascal@16041 184 blkid | sed "/$dev:/!d;s/.* UUID=.\\([^ ]*\\)\".*/\\1/"
pascal@13691 185 }
pascal@13691 186
pascal@16055 187 tazusbinitfs()
pascal@16055 188 {
pascal@16055 189 PAD=$(($(stat -c %s $1) % 4))
pascal@17454 190 [ $PAD -ne 0 ] && ddq if=/dev/zero bs=1 count=$((4 - $PAD)) >> $1
pascal@16055 191 mkdir -p /tmp/fs/etc /tmp/fs/lib /tmp/fs/home
pascal@16055 192 cp -a /etc/locale.conf /tmp/fs/etc 2> /dev/null
pascal@16055 193 cp -a /etc/keymap.conf /tmp/fs/etc 2> /dev/null
pascal@16055 194 sed 's/ .*//' /proc/modules | while read mod ; do
pascal@16055 195 find /lib/modules/ | grep $mod.ko | \
pascal@16055 196 sed 's|.*|cp & /tmp/fs/lib|' | sh
pascal@16055 197 done
pascal@16055 198 cat > /tmp/fs/init1 <<EOT
pascal@16055 199 #!/bin/sh
pascal@16055 200 sed -i 's|sbin/init|init2|' /init
pascal@16055 201 exec /init
pascal@16055 202 EOT
pascal@16055 203 cat > /tmp/fs/init2 <<EOT
pascal@16055 204 #!/bin/sh
pascal@16055 205
pascal@16055 206 mount -t proc /proc /proc
pascal@16055 207 grep -q debug /proc/cmdline && debug=true && set -x
pascal@16055 208 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
pascal@16055 209 v=\$(sed '/\\/home=/!d;s|.*/home=\\([^ ]*\\).*|\\1|' /proc/cmdline /cmdline 2> /dev/null)
pascal@16055 210 mount / -o remount,rw
pascal@16055 211 mkdir /mnt/dos
pascal@16055 212 rm -f /cmdline 2> /dev/null
pascal@16055 213 mount / -o remount,ro
pascal@16055 214 mnt=/mnt/dos/\${v#*/}
pascal@16055 215 dev=\$( (blkid /dev/[sh]d* || blkid) | grep \${v%%/*} | sed 's/:.*//;q')
pascal@16055 216 echo "Mount \$dev in /mnt/dos for \$v..." | tee -a /run/boot.log
pascal@16055 217 mount \$dev /mnt/dos
pascal@16055 218 mount.posixovl -F \$mnt -- -oallow_other -odefault_permissions -osuid
pascal@16055 219 mount --bind \$mnt /home
pascal@16055 220 [ "\$debug" = "true" ] && sh
pascal@16055 221 umount /proc
pascal@16055 222 exec /sbin/init
pascal@16055 223 EOT
pascal@16055 224 chmod 755 /tmp/fs/init?
pascal@16055 225 cp -a /tmp/fs/* /
pascal@16055 226 ( cd /tmp/fs ; find * | cpio -o -H newc ) | gzip -9 >> $1
pascal@16055 227 }
pascal@16055 228
pascal@13691 229 mkinitrd()
pascal@13691 230 {
pascal@17476 231 dotwait "Creating $(basename $1) "
pascal@13691 232 for i in bin lib dev proc tmp mnt etc ; do
pascal@13691 233 mkdir -p /tmp/fs/$i
pascal@13691 234 done
pascal@17476 235 for i in /dev/console /dev/null /dev/tty /dev/tty0 /dev/tty1 /dev/tty2 \
pascal@17476 236 /dev/fuse /dev/hd* /dev/sd* ; do
pascal@13691 237 cp -a $i /tmp/fs$i
pascal@13691 238 done
pascal@13713 239 for i in /bin/busybox $(which mount.posixovl) $(which blkid); do
pascal@13691 240 cp $(LD_TRACE_LOADED_OBJECTS=1 /lib/ld*.so $i | \
pascal@13691 241 sed 's|.*=> \(.*/lib/l[^ ]*\).*|\1|;/^\//!d') /tmp/fs/lib
pascal@13691 242 cp $i /tmp/fs/bin
pascal@13691 243 done
pascal@13691 244 cp -a /lib/ld-* /tmp/fs/lib
pascal@13691 245 for i in $(busybox | sed '/Current/,$!d'); do
pascal@14271 246 [ -e /tmp/fs/bin/${i%,} ] || ln -s busybox /tmp/fs/bin/${i%,}
pascal@13691 247 done
pascal@13691 248 ln -s /proc/mounts /tmp/fs/etc/mtab
pascal@16041 249 sed 's/ .*//' /proc/modules | while read mod ; do
pascal@16041 250 find /lib/modules/ | grep $mod.ko | \
pascal@16041 251 sed 's|.*|cp & /tmp/fs/lib|' | sh
pascal@16041 252 done
pascal@13691 253 cat > /tmp/fs/init <<EOT
pascal@13691 254 #!/bin/sh
pascal@13691 255
pascal@13691 256 arg()
pascal@13691 257 {
pascal@13691 258 grep -q \$1 /proc/cmdline &&
pascal@13691 259 val="\$(sed "s/.*\$1=\\([^ ]*\\).*/\\1/" < /proc/cmdline)" &&
pascal@13691 260 echo "\$2 \$val"
pascal@13691 261 }
pascal@13691 262
pascal@13691 263 mount -t proc /proc /proc
pascal@16041 264 arg debug "shell" && debug=true && set -x
pascal@16055 265 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
pascal@13691 266 arg mount "Mount device"
pascal@16055 267 mount \$( (blkid /dev/[sh]d* || blkid) | grep \$val | sed 's/:.*//;q') /mnt
pascal@13691 268 arg subroot "Change root to directory"
pascal@16041 269 mount.posixovl -F /mnt/\$val -- -oallow_other -odefault_permissions -osuid
pascal@13691 270 mount --bind /mnt /mnt/\$val/mnt/dos
pascal@17454 271 mount -o size=0 -t tmpfs tmpfs /mnt/\$val/mnt/dos/\$val
pascal@13691 272 LDSO=\$(ls /mnt/\$val/lib/ld-* | sed q)
pascal@16041 273 export LD_LIBRARY_PATH=\$val/lib:\$val/usr/lib:/lib
pascal@16041 274 [ "$debug" = "true" ] && sh
pascal@13691 275 umount /proc
pascal@13691 276 exec /bin/switch_root /mnt \${LDSO#/mnt/} \$val/usr/sbin/chroot \$val /sbin/init
pascal@13691 277 EOT
pascal@13691 278 chmod +x /tmp/fs/init
pascal@13691 279 ( cd /tmp/fs ; find * | cpio -o -H newc ) | lzma e $1 -si 2> /dev/null
pascal@17476 280 rm -rf /tmp/fs /tmp/wait
pascal@13691 281 }
pascal@13691 282
pascal@13713 283 is_loram()
pascal@13713 284 {
pascal@21459 285 [ -s /lib/modules/squashfs.ko* ]
pascal@13713 286 }
pascal@13713 287
pascal@16041 288 ls_r()
pascal@16041 289 {
pascal@16041 290 ls -r $@ 2> /dev/null || ls $@
pascal@16041 291 }
pascal@16041 292
pascal@13691 293 doinstall()
pascal@13691 294 {
pascal@14271 295 mkdir -p /mnt/slitaz/boot /mnt/slitaz/mnt/dos
pascal@16041 296 if ! mount.posixovl -F /mnt/slitaz -- \
pascal@16041 297 -oallow_other -odefault_permissions -osuid; then
pascal@16041 298 echo "Can't install SliTaz. Abort."
pascal@16041 299 sleep 5
pascal@16041 300 return 1
pascal@16041 301 fi
pascal@17635 302 dotwait "Install root filesystem in /slitaz.."
pascal@17454 303 if [ "$1" ]; then
pascal@14271 304 if [ -d /media/cdrom/fs ]; then
pascal@14271 305 ( cd /mnt/slitaz/fs; find | cpio -o -H newc ) | gzip -9
pascal@14271 306 else
pascal@17635 307 ls_r /media/cdrom/boot/rootfs*gz | xargs cat
pascal@14271 308 fi > /mnt/slitaz/boot/rootfs.gz
pascal@16055 309 tazusbinitfs /mnt/slitaz/boot/rootfs.gz
pascal@14271 310 initrd=rootfs.gz
pascal@16055 311 extraargs="/home=$(getuuid)/slitaz rdinit=/init1"
pascal@13713 312 else
pascal@14271 313 if [ -d /media/cdrom/fs ]; then
pascal@14271 314 cp -a /media/cdrom/fs/. /mnt/slitaz
pascal@14271 315 elif is_loram ; then
pascal@17473 316 for i in /media/cdrom/boot/rootfs?*.* ; do
pascal@14271 317 [ -s $(basename $i) ] && continue
pascal@14271 318 cpio -i $i
pascal@14271 319 done
pascal@17635 320 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@14271 321 mount -o loop,ro $i /sqfs/mnt
pascal@14271 322 cp -a /sqfs/mnt/. /mnt/slitaz
pascal@14271 323 umount -d /sqfs/mnt
pascal@14271 324 done
pascal@14271 325 else
pascal@17635 326 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@14271 327 uncpio $i /mnt/slitaz
pascal@14271 328 done
pascal@14271 329 fi
pascal@17635 330 cp -a /etc/locale.conf /mnt/slitaz/etc 2> /dev/null
pascal@17635 331 cp -a /etc/keymap.conf /mnt/slitaz/etc 2> /dev/null
pascal@14271 332 mkinitrd /mnt/slitaz/boot/initrd
pascal@14271 333 initrd=initrd
pascal@14271 334 extraargs="mount=$(getuuid) subroot=slitaz"
pascal@13713 335 fi
pascal@17476 336 echo -en "\nInstall boot files..."
pascal@13691 337 for i in /media/cdrom/boot/bzImage /media/cdrom/boot/*pxe* \
pascal@13691 338 /media/cdrom/boot/isolinux/he* /media/cdrom/boot/isolinux/opt* \
pascal@13691 339 /media/cdrom/README /media/cdrom/boot/memtest* ; do
pascal@13691 340 [ -s $i ] && cp $i /mnt/slitaz/boot
pascal@13691 341 done
pascal@16047 342 for i in /mnt/slitaz/boot/memtest /mnt/slitaz/boot/*pxe* ; do
pascal@16047 343 [ $(get 0 $i 2> /dev/null || echo 0) -eq 23117 ] &&
pascal@16047 344 mv $i $i.exe
pascal@16047 345 done
pascal@13691 346 gettazboot /mnt/slitaz/boot/tazboot.exe
pascal@14247 347 unix2dos > /mnt/slitaz/boot/tazboot.cmd <<EOT
pascal@16041 348 kernel=/slitaz/boot/bzimage
pascal@16041 349 initrd=/slitaz/boot/$initrd
pascal@14271 350 rw root=/dev/null $extraargs autologin
pascal@13691 351 EOT
pascal@13691 352 unix2dos /mnt/slitaz/boot/he* /mnt/slitaz/boot/opt* \
pascal@14247 353 /mnt/slitaz/boot/README
pascal@14271 354 [ -d /mnt/slitaz/usr/sbin -a ! -x /mnt/slitaz/usr/sbin/mount.posixovl ] &&
pascal@13713 355 cp $(which mount.posixovl) /mnt/slitaz/usr/sbin
pascal@17476 356 rm -f /tmp/wait
pascal@16041 357 false &&
pascal@17476 358 [ -s /mnt/boot.ini ] && ! grep -qs tazboot /mnt/boot.ini &&
pascal@17476 359 echo "Update boot.ini ..." && unix2dos >> /mnt/boot.ini <<EOT
pascal@13691 360 C:\\slitaz\\boot\\tazboot.exe="SliTaz"
pascal@13691 361 EOT
pascal@16073 362 false &&
pascal@16073 363 grep -qis menuitem /mnt/config.sys && ! grep -qi tazboot /mnt/config.sys &&
pascal@16041 364 echo "Update config.sys ..." &&
pascal@16073 365 sed -i 's/menudefault/menuitem SLITAZ, SliTaz\r\n&/' /mnt/config.sys &&
pascal@16073 366 unix2dos >> /mnt/config.sys <<EOT
pascal@16073 367 [SLITAZ]
pascal@16073 368 install=\\slitaz\\boot\\tazboot.exe
pascal@13691 369 EOT
pascal@16041 370 return 0
pascal@13691 371 }
pascal@13691 372
pascal@13691 373 install()
pascal@13691 374 {
pascal@20771 375 $DIALOG --clear --title " SliTaz UMSDOS way installation " \
pascal@13691 376 --yes-label "Install" --yesno \
pascal@13691 377 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
pascal@13691 378 DOS/Windows partition. You will see your files from /mnt/dos.\n\n
paul@13692 379 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
pascal@13691 380 To uninstall SliTaz, you have only to remove this directory.
pascal@13691 381 The file \\boot.ini or \\config.sys may be modified too.\n\n
pascal@20771 382 SliTaz may run slowly on the 'UMSDOS way' installation due to the
paul@14320 383 posixovl filesystem. The 'TAZUSB way' installation runs faster.\n\n
pascal@13697 384 To do a traditional installation with disk partitioning,
pascal@20771 385 start SliTaz Live with the 'SliTaz RAM boot' menu.\n" 19 70
pascal@14271 386 [ $? -eq 0 ] || return
pascal@16041 387 doinstall || return
pascal@16041 388 [ -x /mnt/slitaz/sbin/init ] || return
pascal@14271 389 umount -d /media/cdrom
pascal@16041 390 umount_proc
pascal@13691 391 exec chroot /mnt/slitaz /sbin/init
pascal@13691 392 }
pascal@13691 393
pascal@14271 394 installtaz()
pascal@14271 395 {
pascal@20771 396 $DIALOG --clear --title " SliTaz TAZUSB way installation " \
pascal@14271 397 --yes-label "Install" --yesno \
pascal@14271 398 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
pascal@14271 399 DOS/Windows partition. You will see your files from /mnt/dos.\n\n
pascal@14271 400 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
pascal@14271 401 To uninstall SliTaz, you have only to remove this directory.
pascal@14271 402 The file \\boot.ini or \\config.sys may be modified too.\n\n
pascal@14271 403 The filesystem is loaded entirely into memory upon boot to
paul@19451 404 increase responsiveness. Only /home lands on the hard disk.\n\n
pascal@14271 405 To do a traditional installation with disk partitioning,
pascal@20771 406 start SliTaz Live with the 'SliTaz RAM boot' menu.\n" 19 70
pascal@14271 407 [ $? -eq 0 ] || return
pascal@16041 408 doinstall tazusblike || return
pascal@20771 409 dotwait
pascal@14271 410 if [ -d /media/cdrom/fs ]; then
pascal@16055 411 cp -a /media/cdrom/fs/. /
pascal@14271 412 else
pascal@17635 413 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@17454 414 uncpio $i
pascal@14271 415 done
pascal@14271 416 fi
pascal@16055 417 cp /tmp/fs/etc/* /etc
pascal@16055 418 echo "/home=$(getuuid)/slitaz" > /cmdline
pascal@17476 419 rm -f /tmp/wait
pascal@16055 420 [ -x /init1 ] || return
pascal@14271 421 umount -d /media/cdrom
pascal@16055 422 umount /mnt/slitaz
pascal@16073 423 rm -f /dev/cdrom
pascal@16055 424 umount /mnt
pascal@16055 425 mkdir /mnt/dos
pascal@16041 426 umount_proc
pascal@16055 427 exec /init1
pascal@14271 428 }
pascal@14271 429
pascal@13691 430 tazboot()
pascal@13691 431 {
pascal@20771 432 $DIALOG --clear --title " SliTaz bootloader for DOS " \
pascal@13691 433 --yes-label "Install" --yesno \
paul@13692 434 "\nThe file TAZBOOT.EXE will be created in the top directory. It supports
pascal@17476 435 any linux kernel, multiple initramfs, a kernel command line and
paul@13692 436 an ISO image file loopback (retrieves files from an ISO file).\n\n
pascal@20771 437 Usage: tazboot.exe [[@commands]|[kernel=<bzimage>]
pascal@17489 438 [initrd=<rootfs>[,<rootfs2>...]] [bootfrom=<isofile>] cmdline args ...]\n\n
paul@13692 439 Defaults: tazboot @tazboot.cmd or tazboot kernel=bzImage auto\n\n\
pascal@13691 440 Examples for tazboot.cmd:\n\n\
pascal@17489 441 bootfrom=\\isos\\slitaz-4.0.iso\n\
pascal@13691 442 kernel=boot/bzImage\n\
pascal@13691 443 initrd=boot/rootfs4.gz,boot/rootfs3.gz,boot/rootfs2.gz,boot/rootfs1.gz\n\
pascal@13691 444 rw root=/dev/null autologin\n\n\
pascal@13691 445 kernel=\\slitaz\\vmlinuz root=/dev/sda5 ro\n\n
pascal@20771 446 Unlike GRUB4DOS, it doesn't require unfragmented ISO image files.\n" 24 78
pascal@13691 447 [ $? -eq 0 ] || return
pascal@13691 448 gettazboot /mnt/tazboot.exe
pascal@13691 449 }
pascal@13691 450
pascal@13697 451 md5()
pascal@13697 452 {
pascal@17476 453 dotwait "Checking files"
pascal@18061 454 ( cd /media/cdrom ; ${1:-md5sum -c md5sum*} | sort ) > /tmp/data
pascal@17476 455 rm -f /tmp/wait
pascal@20771 456 $DIALOG --clear --title " Checked files " --textbox /tmp/data 24 78
pascal@13697 457 rm -f /tmp/data
pascal@13697 458 }
pascal@13697 459
pascal@17491 460 gotcdfile()
pascal@17491 461 {
pascal@17635 462 for i in "/media/cdrom/$1" "/media/cdrom/*/$1" \
pascal@17635 463 "/media/cdrom/*/isolinux/$1" ; do
pascal@17491 464 file=$(ls $i 2> /dev/null | sed q)
pascal@17491 465 [ -s "$file" ] && break
pascal@17491 466 done
pascal@17491 467 }
pascal@17491 468
pascal@17489 469 sha()
pascal@17489 470 {
pascal@17635 471 gotcdfile "sha*sum*"
pascal@17489 472 sha=$(basename $file)
pascal@17489 473 md5 "${sha%sum*}sum -c ${file#/media/cdrom/}"
pascal@17489 474 }
pascal@17489 475
pascal@13697 476 readme()
pascal@13697 477 {
pascal@17635 478 gotcdfile "README*"
pascal@20771 479 $DIALOG --clear --title " Readme " --textbox $file 24 78
pascal@13697 480 }
pascal@13697 481
pascal@13697 482 bootlog()
pascal@13697 483 {
pascal@20771 484 $DIALOG --clear --title " Linux boot messages " \
pascal@13697 485 --textbox /tmp/dmesg 24 78
pascal@13697 486 }
pascal@13697 487
pascal@17476 488 bzimage()
pascal@17476 489 {
pascal@20771 490 $DIALOG --clear --title " Create linux.exe ? " \
pascal@17476 491 --yes-label "Install" --yesno \
pascal@17476 492 "\nLinux.exe launches the linux kernel under DOS (in real mode only).
pascal@17569 493 The cmdline arguments are supported except initrd=,
pascal@17569 494 vga= (you can try 'rdev -v') and mem= (partially).
pascal@17569 495 \nExample:\nC:\\> linux.exe root=/dev/hda2 ro panic=60\n
pascal@17476 496 " 12 70
pascal@17476 497 [ $? -eq 0 ] || return
pascal@17476 498 cp /media/cdrom/boot/bzImage /mnt/linux.exe
pascal@17476 499 }
pascal@17476 500
pascal@13697 501 memtest()
pascal@13697 502 {
pascal@20771 503 $DIALOG --clear --title " Create memtest.exe ? " \
pascal@13697 504 --yes-label "Install" --yesno \
pascal@13697 505 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
pascal@13697 506 computers. BIOS based memory tests are a quick, cursory check and often
pascal@20771 507 miss many of the failures that are detected by Memtest86.\n" 12 70
pascal@17635 508 [ $? -eq 0 ] && gotcdfile "memtest*" && cp $file /mnt/memtest.exe
pascal@13697 509 }
pascal@13697 510
pascal@17489 511 mkfat12()
pascal@17473 512 {
pascal@17473 513 [ $(($(get 0 $1) - 0x5A4D)) -eq 0 ] || return
pascal@17473 514 J=$(($(get 3 $1 1) + 0x02))
pascal@17473 515 R=$((1 + $(get 497 $1 1) + 1 + ($(get 500 $1)-1)/32))
pascal@17473 516 [ $R -lt 2500 ] || return
pascal@17476 517 [ $((($(get 500 $1)-1) & 31)) -lt 30 ] &&
pascal@17474 518 ddq if=$file bs=32 count=1 seek=$(($R*16 - 1)) of=/dev/fd0
pascal@17473 519 G="18 0 2 0 0 0 0 0"
pascal@17473 520 [ $J -gt 25 ] || G=""
pascal@17473 521 F=0
pascal@17473 522 for i in 1 2 3; do
pascal@17473 523 F=$((((2880-$R-$F-$F)*3+1023)/1024))
pascal@17473 524 done
pascal@17473 525 bytes2bin 0xEB $J 0x90 0x20 0x20 0x20 0x20 0x20 0x20 0x20 0x20 \
pascal@17473 526 0 2 2 $(($R%256)) $(($R/256)) 2 64 0 64 11 0xF0 $F 0 \
pascal@17473 527 $G | ddq bs=1 of=/dev/fd0
pascal@17473 528 ddq if=/dev/zero bs=512 count=$((4+$F+$F)) seek=$R of=/dev/fd0
pascal@17473 529 for i in $R $(($R+$F)) ; do
pascal@17473 530 bytes2bin 0xF0 0xFF 0xFF | ddq bs=512 seek=$i of=/dev/fd0
pascal@17473 531 done
pascal@17473 532 echo -n $(basename $1) | ddq bs=1 seek=3 count=8 of=/dev/fd0
pascal@17489 533 }
pascal@17489 534
pascal@17489 535 mkfloppy()
pascal@17489 536 {
pascal@17489 537 dotwait "Create a $(basename $1) boot floppy"
pascal@17489 538 ddq if=$1 of=/dev/fd0
pascal@17489 539 mkfat12 $1
pascal@17476 540 rm -f /tmp/wait
pascal@17473 541 }
pascal@17473 542
pascal@13697 543 fdmemtest()
pascal@13697 544 {
pascal@20771 545 $DIALOG --clear --title " Create a Memtest86 boot floppy " \
pascal@13697 546 --yes-label "Create floppy" --yesno \
pascal@13697 547 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
pascal@13697 548 computers. BIOS based memory tests are a quick, cursory check and often
pascal@13697 549 miss many of the failures that are detected by Memtest86.\n\n
pascal@20771 550 Please insert a blank disk in floppy drive.\n" 12 70
pascal@17635 551 [ $? -eq 0 ] && gotcdfile "memtest*" && mkfloppy $file
pascal@13697 552 }
pascal@13697 553
pascal@16013 554 pxe()
pascal@13697 555 {
pascal@20762 556 gotcdfile "?pxe*"
pascal@20771 557 $DIALOG --clear --title " Create $(basename $file).exe ? " \
pascal@13697 558 --yes-label "Install" --yesno \
pascal@13697 559 "\nBoot your operating system from the internet and enjoy a full system
pascal@13697 560 working entirely in RAM with speed and stability in mind. The Linux Kernel
pascal@13697 561 and the complete SliTaz compressed root filesystem will be loaded into RAM
pascal@20771 562 from the Web using PXE and HTTP protocols.\n" 12 70
pascal@13697 563 [ $? -eq 0 ] || return
pascal@17491 564 cp $file /mnt/$(basename $file).exe
pascal@13697 565 }
pascal@13697 566
pascal@16013 567 fdpxe()
pascal@13697 568 {
pascal@20771 569 $DIALOG --clear --title " Create a SliTaz Web boot floppy " \
pascal@13697 570 --yes-label "Create floppy" --yesno \
pascal@13697 571 "\nBoot your operating system from the internet and enjoy a full system
pascal@13697 572 working entirely in RAM with speed and stability in mind. The Linux Kernel
pascal@13697 573 and the complete SliTaz compressed root filesystem will be loaded into RAM
pascal@13697 574 from the Web using PXE and HTTP protocols.\n\n
pascal@20771 575 Please insert a blank disk in floppy drive.\n" 12 70
pascal@20762 576 [ $? -eq 0 ] && gotcdfile "?pxe*" && mkfloppy $file
pascal@13697 577 }
pascal@13697 578
pascal@16041 579 gotposixovl()
pascal@16041 580 {
pascal@20771 581 mount.posixovl 2>&1 | grep -qi usage &&
pascal@16041 582 echo -en "\"$1\" \"$2\""
pascal@16041 583 }
pascal@16041 584
pascal@14271 585 xfile()
pascal@14271 586 {
pascal@17454 587 [ "$(which $1)" ] && echo -en "\"$2\" \"$3\""
pascal@14271 588 }
pascal@14271 589
pascal@13697 590 cdfile()
pascal@13697 591 {
pascal@17489 592 gotcdfile "$1" && echo -en "\"$2\" \"$3\""
pascal@17476 593 }
pascal@17476 594
pascal@17659 595 isbzImage()
pascal@17659 596 {
pascal@17659 597 [ $(get 514 $file 4) -eq 1400005704 ] &&
pascal@17659 598 [ $(($(get 529 $file 1) & 1)) -eq 1 ]
pascal@17659 599 }
pascal@17659 600
pascal@17476 601 cdfilex()
pascal@17476 602 {
pascal@17659 603 gotcdfile "$1" &&
pascal@17659 604 [ "$(which kexec)" ] &&
pascal@17659 605 isbzImage &&
pascal@17659 606 echo -en "\"$2\" \"$3\""
pascal@14271 607 }
pascal@14271 608
pascal@17491 609 cdfilef()
pascal@17491 610 {
pascal@17491 611 [ -e /sys/block/fd0 ] && cdfile "$@"
pascal@17491 612 }
pascal@17491 613
pascal@16022 614 cdexe()
pascal@16022 615 {
pascal@17489 616 gotcdfile "$1" &&
pascal@17489 617 [ $(get 0 $file 2>/dev/null || echo 0) -eq 23117 ] &&
pascal@16022 618 echo -en "\"$2\" \"$3\""
pascal@16022 619 }
pascal@16022 620
pascal@14271 621 fddata()
pascal@14271 622 {
pascal@20771 623 [ -e /sys/block/fd0 ] &&
pascal@18771 624 [ $(get 26 /mnt/$ISO 1 2> /dev/null || echo 0) -ne 0 ] &&
pascal@14271 625 echo -en "\"$1\" \"$2\""
pascal@13697 626 }
pascal@13697 627
pascal@17491 628 ishybrid()
pascal@17491 629 {
pascal@19510 630 [ $(get 510 $ISO 2> /dev/null || echo 0) -eq 43605 ] || return
pascal@17491 631 C=$((2048*$(get $(((17*2048) + 71)) /mnt/$ISO 4)))
pascal@17491 632 [ $(get $C /mnt/$ISO 4) -eq 1 ] || return
pascal@17491 633 [ $(get $(($C+30)) /mnt/$ISO 4) -eq $((0x88AA55)) ] || return
pascal@17491 634 C=$((2048*$(get $(($C+40)) /mnt/$ISO 4)))
pascal@17491 635 [ $(get $(($C+64)) /mnt/$ISO 4) -eq 1886961915 ] &&
pascal@17491 636 echo -en "\"$1\" \"$2\""
pascal@17491 637 }
pascal@17491 638
pascal@18034 639 burnable()
pascal@18034 640 {
pascal@19510 641 [ "$(sed '/Can wr.*1$/!d' /proc/sys/dev/cdrom/info 2> /dev/null)" ] &&
pascal@18034 642 [ "$(which wodim)" ] && echo -en "\"$1\" \"$2\""
pascal@18034 643 }
pascal@18034 644
pascal@18034 645 blankable()
pascal@18034 646 {
pascal@19510 647 [ "$(sed '/Can wr.*RW.*1$/!d' /proc/sys/dev/cdrom/info 2> /dev/null)" ] &&
pascal@18034 648 [ "$(which wodim)" ] && echo -en "\"$1\" \"$2\""
pascal@18034 649 }
pascal@18034 650
pascal@18034 651 burniso()
pascal@18034 652 {
pascal@18034 653 wodim -v speed=$(fgrep "drive speed" /proc/sys/dev/cdrom/info | cut -f3) \
pascal@18034 654 -eject -multi "$ISO"
pascal@18034 655 }
pascal@18034 656
pascal@18034 657 blankcd()
pascal@18034 658 {
pascal@18034 659 wodim -v -blank=fast
pascal@18034 660 }
pascal@18034 661
pascal@18771 662 customsector()
pascal@18771 663 {
pascal@19324 664 echo $(get 32848 "/mnt/$ISO" 4)
pascal@18771 665 }
pascal@18771 666
pascal@18771 667 hascustomconf()
pascal@18771 668 {
pascal@18771 669 [ "$(ddq bs=2k skip=$(customsector) if="/mnt/$ISO" | ddq bs=1 count=6)" \
pascal@20891 670 = "#!boot" ]
pascal@18771 671 }
pascal@18771 672
pascal@18771 673 gotcustomconf()
pascal@18771 674 {
pascal@18774 675 hascustomconf && echo -en "\"$1\" \"$2\""
pascal@18771 676 }
pascal@18771 677
pascal@18771 678 getcustomconf()
pascal@18771 679 {
pascal@18774 680 cd ${1:-/mnt}
pascal@18774 681 ddq bs=2k skip=$(customsector) if="/mnt/$ISO" | while read line; do
pascal@18771 682 case "$line" in
pascal@18771 683 \#!boot*) ;;
pascal@18771 684 append=*) echo ${line#append=} > cmdline && ls -l cmdline ;;
pascal@18771 685 initrd:*) cnt=${line#initrd:}
pascal@18771 686 { ddq bs=512 count=$(($cnt / 512));
pascal@18771 687 ddq bs=1 count=$(($cnt % 512)); } > initrd &&
pascal@18771 688 ls -l initrd
pascal@18771 689 break ;;
pascal@20771 690 *) break ;;
pascal@18771 691 esac
pascal@18771 692 done
pascal@18771 693 cd - > /dev/null
pascal@18774 694 [ -z "$1" ] && echo -e "\rPress RETURN to continue." && read n
pascal@18771 695 }
pascal@18771 696
pascal@17492 697 gotisomd5()
pascal@17492 698 {
pascal@17562 699 [ "$(which md5sum 2> /dev/null)" ] &&
pascal@17635 700 [ $(get 0 /mnt/$ISO) -eq 23117 ] &&
pascal@17635 701 [ $(get 18 /mnt/$ISO) -ne 0 ] && echo -en "\"$1\" \"$2\""
pascal@17492 702 }
pascal@17492 703
pascal@17492 704 isomd5()
pascal@17492 705 {
pascal@17492 706 dotwait "Checking iso image"
pascal@17635 707 [ "$(ddq if=/mnt/$ISO bs=2k skip=16 \
pascal@20891 708 count=$(($(get 32848 /mnt/$ISO 4)-16)) | md5sum)" = \
pascal@17635 709 "$(ddq if=/mnt/$ISO bs=16 count=1 skip=2047 | od -N 16 -t x1 -An | \
pascal@17496 710 sed 's/ //g') -" ] && echo "OK" || echo "ERROR"
pascal@17635 711 echo -en "\rChecking iso hybrid boot..."
pascal@17635 712 n=$(($(get 2 /mnt/$ISO)-1+($(get 4 /mnt/$ISO)-1)*512))
pascal@17635 713 if [ $n -lt 40000 -a $n -gt 32768 ]; then
pascal@17635 714 s=$(get 0 /mnt/$ISO 2 $n | awk '{ i+= $0 } END { print i }')
pascal@17635 715 [ $(((1+$s+$(get $(($n+1)) /mnt/$ISO 1)) % 65536)) -eq 0 ] &&
pascal@17635 716 echo "OK" || echo "ERROR"
pascal@17635 717 fi
pascal@18771 718 if hascustomconf; then
pascal@18771 719 echo -en "\rChecking iso custom config..."
pascal@18771 720 TMP=/tmp/$(basename $0)$$md5
pascal@18771 721 md5="$(ddq bs=2k skip=$(customsector) if=/mnt/$ISO | while read line; do
pascal@18771 722 case "$line" in
pascal@18771 723 \#!boot*) echo ${line#*boot } > $TMP ;;
pascal@18771 724 append=*) echo $line ;;
pascal@18771 725 initrd:*) echo $line
pascal@18771 726 cnt=${line#initrd:}
pascal@18771 727 ddq bs=512 count=$((cnt / 512))
pascal@18771 728 ddq bs=1 count=$((cnt % 512))
pascal@18771 729 break ;;
pascal@20771 730 *) break ;;
pascal@18771 731 esac
pascal@18771 732 done | md5sum | cut -c1-32)"
pascal@20891 733 [ "$md5" = "$(cat $TMP)" ] && echo "OK" || echo "ERROR"
pascal@18771 734 rm -f $TMP
pascal@18771 735 fi
pascal@17492 736 rm -f /tmp/wait
pascal@17562 737 echo -e "\rPress RETURN to continue."
pascal@17496 738 read n
pascal@17492 739 }
pascal@17492 740
pascal@20891 741 if [ "$1" = "--build" ]; then #install-begin
pascal@20763 742 cp $0 $0.tmp
pascal@20763 743 uuencode -m - < ifmem.bin | sed -e 's|^[ \t]*||;s|[ \t]*###.*||' \
pascal@20771 744 -e 's| *;;|;;|;s|\t\t*|\t|g' \
pascal@20763 745 -e '/^ifmemcode$/r/dev/stdin' -e '/^ifmemcode$/d' -i $0.tmp
pascal@18771 746 uuencode -m - < bootloader.bin | sed -e '/^bootloader$/r/dev/stdin' \
pascal@20764 747 -e '/^bootloader$/d' -e '/install-begin$/,/install-end$/d' -i $0.tmp
pascal@20763 748 mv -f $0.tmp $0; exit
pascal@18771 749 fi #install-end
pascal@18771 750 parse_isolinux()
pascal@18771 751 {
pascal@18771 752 awk 'BEGIN { IGNORECASE=1 }
pascal@18771 753 function multi(n)
pascal@18771 754 {
pascal@18771 755 auto=$n
pascal@18771 756 for (--n; n < NF; n+=2) {
pascal@18771 757 s=$n
pascal@18771 758 if (s ~ /M$/) s = substr(s,0,length(s)-1)
pascal@18771 759 else s /= 1024
pascal@18771 760 sizes=int(s) " " sizes
pascal@18771 761 }
pascal@18771 762 next
pascal@18771 763 }
pascal@18771 764 {
pascal@18771 765 if ($1 == "LABEL") {
pascal@18771 766 label=$2
pascal@18771 767 if (auto == "") auto=label
pascal@18771 768 }
pascal@18771 769 if ($1 == "KERNEL" || $1 == "COM32") kernel[label]=$2
pascal@18771 770 if ($1 == "INITRD") initrd[label]=$2
pascal@18771 771 if ($1 == "APPEND") {
pascal@18771 772 i=2
pascal@18771 773 if (kernel[label] ~ "ifmem.c32") multi(3)
pascal@18771 774 if (kernel[label] ~ "c32box.c32") {
pascal@18771 775 if ($2 == "linux") { kernel[label]=$3; i=4 }
pascal@18771 776 if ($2 == "ifmem") multi(4)
pascal@18771 777 }
pascal@18771 778 if (kernel[label] ~ "ifcpu64.c32") { auto=$4; next }
pascal@18771 779 while (i <= NF) {
pascal@18771 780 if ($i ~ "^initrd=") initrd[label]=substr($i,8)
pascal@18771 781 else cmdline[label]=cmdline[label] " " $i
pascal@18771 782 i++
pascal@18771 783 }
pascal@18771 784 }
pascal@18771 785 }
pascal@18771 786 END {
pascal@18771 787 print "KERNEL=\"" kernel[auto] "\""
pascal@18771 788 print "INITRD=\"" initrd[auto] "\""
pascal@18771 789 print "CMDLINE=\"" substr(cmdline[auto],2) "\""
pascal@18771 790 print "SIZES=\"" sizes "\""
pascal@18771 791 }'
pascal@18771 792 }
pascal@18771 793
pascal@18771 794 locase()
pascal@18771 795 {
pascal@18771 796 echo "$1" | tr [A-Z] [a-z]
pascal@18771 797 }
pascal@18771 798
pascal@18771 799 ifmemcode()
pascal@18771 800 {
pascal@18771 801 uudecode <<EOT
pascal@18771 802 ifmemcode
pascal@18771 803 EOT
pascal@18771 804 }
pascal@18771 805
pascal@18771 806 floppyset()
pascal@18771 807 {
pascal@18771 808 gotcdfile isolinux.cfg
pascal@18771 809 parse_isolinux < $file > /tmp/var$$
pascal@18771 810 . /tmp/var$$
pascal@19877 811 for i in /media/cdrom/$KERNEL $(dirname $file)/$KERNEL /media/cdrom/$(locase $KERNEL) \
pascal@18771 812 $(dirname $file)/$(locase $KERNEL); do
pascal@18771 813 [ -s $i ] && KERNEL=$i && break
pascal@18771 814 done
pascal@20771 815 rm -f /tmp/var$$
pascal@18771 816 [ $(get 514 $KERNEL 4) -eq 1400005704 ] || return
pascal@18771 817 n=$(($(get 497 $KERNEL 1)+1))
pascal@18771 818 ddq bs=512 count=$n if=$KERNEL of=/tmp/fd$$
pascal@18771 819 uudecode <<EOT | ddq of=/tmp/fd$$ conv=notrunc
pascal@18771 820 bootloader
pascal@18771 821 EOT
pascal@18771 822 pos=$(($n*512))
pascal@18771 823 if [ -n "$CMDLINE" ]; then
pascal@18771 824 echo -n "$CMDLINE" | ddq bs=512 count=1 conv=sync >> /tmp/fd$$
pascal@18771 825 bytes2bin $n | ddq conv=notrunc \
pascal@18771 826 bs=1 seek=497 count=1 of=/tmp/fd$$
pascal@18771 827 words2bin $pos | ddq conv=notrunc \
pascal@18771 828 bs=1 seek=34 count=2 of=/tmp/fd$$
pascal@18771 829 [ $(get 518 $KERNEL 4) -ge 514 ] &&
pascal@18771 830 words2bin 32768 9 | ddq conv=notrunc \
pascal@18771 831 bs=1 seek=552 count=4 of=/tmp/fd$$
pascal@18771 832 fi
pascal@18771 833 syssize=$(echo $(get 500 /tmp/fd$$ 4))
pascal@18771 834 ddq bs=512 skip=$n if=$KERNEL | cat - /dev/zero | \
pascal@18771 835 ddq bs=512 count=$((($syssize+31)/32)) conv=sync >> /tmp/fd$$
pascal@18771 836 base=$(stat -c %s /tmp/fd$$)
pascal@18771 837 len=
pascal@18771 838 if [ "$INITRD" ]; then
pascal@18771 839 l=0
pascal@18771 840 for i in ${INITRD//,/ }; do
pascal@19877 841 for j in /media/cdrom/$i $(dirname $KERNEL)/$i /media/cdrom/$(locase $i) \
pascal@18771 842 $(dirname $KERNEL)/$(locase $i); do
pascal@18771 843 [ -s $j ] && i=$j && break
pascal@18771 844 done
pascal@18771 845 ddq if=$i >> /tmp/fd$$
pascal@18771 846 l=$(($l+$(stat -c %s $i)))
pascal@18771 847 r=$((4 - ($l % 4)))
pascal@18771 848 if [ $r -ne 4 ]; then
pascal@18771 849 ddq if=/dev/zero bs=1 count=$r >> /tmp/fd$$
pascal@18771 850 l=$(($l + $r))
pascal@18771 851 fi
pascal@18771 852 case "$i:$INITRD" in
pascal@20762 853 *rootfs.gz:*rootfs.gz,*) continue ### loram
pascal@18771 854 esac
pascal@18771 855 len="$len $l"; l=0
pascal@18771 856 done
pascal@18771 857 rdadrs=${RDADRS:-$(((($syssize*16)+0x1F0000) & -4096))}
pascal@18771 858 words2bin $(($rdadrs & 0xFFFF)) $(($rdadrs >> 16)) | ddq \
pascal@18771 859 conv=notrunc bs=1 seek=536 count=4 of=/tmp/fd$$
pascal@18771 860 fi
pascal@18771 861 n=$(echo $len | wc -w)
pascal@18771 862 if [ $((494 - $(get 494 /tmp/fd$$))) -ge $(($n * 4)) ]; then
pascal@18771 863 i=$(($(get 494 /tmp/fd$$)))
pascal@18771 864 bytes2bin $(($i + ($n*4) - 256)) | ddq bs=1 conv=notrunc \
pascal@18771 865 seek=496 count=1 of=/tmp/fd$$
pascal@18771 866 else
pascal@18771 867 i=$(($pos + 0x1FC - ($n*4)))
pascal@18771 868 bytes2bin $(($i % 256)) $((i / 256)) 252 | ddq bs=1 \
pascal@18771 869 conv=notrunc seek=494 count=3 of=/tmp/fd$$
pascal@18771 870 s=$(($i - 2*$(echo "$SIZES" | wc -w)))
pascal@18771 871 p=$(($s - $(ifmemcode | wc -c)))
pascal@18771 872 ifmemcode | ddq bs=1 conv=notrunc seek=$p of=/tmp/fd$$
pascal@18771 873 words2bin $SIZES | ddq bs=1 conv=notrunc seek=$s of=/tmp/fd$$
pascal@18771 874 bytes2bin 154 $(($p%256)) $(($p/256)) 0 144 | \
pascal@18771 875 ddq bs=1 conv=notrunc seek=60 of=/tmp/fd$$
pascal@18771 876 fi
pascal@18771 877 for r in $len ; do
pascal@18771 878 words2bin $(($r & 0xFFFF)) $(($r >> 16)) | ddq conv=notrunc \
pascal@18771 879 bs=1 seek=$i count=4 of=/tmp/fd$$
pascal@18771 880 i=$(($i + 4))
pascal@18771 881 done
pascal@18771 882 split -b 1440k /tmp/fd$$ fd$$
pascal@18771 883 rm -f /tmp/fd$$
pascal@18771 884 n=1; i=0; r=0
pascal@18771 885 set -- $len
pascal@18771 886 ls fd$$* | while read file ; do
pascal@18771 887 if [ $i -gt $(($1+$base)) ]; then
pascal@18771 888 shift
pascal@18771 889 r=$(($r+100)); n=0; i=0; base=0
pascal@18771 890 fi
pascal@18771 891 ddq of=$file bs=18k seek=80 count=0
pascal@18771 892 i=$(($i+1474560))
pascal@18771 893 printf "mv %s fd%03d.img\n" $file $(($r+$n))
pascal@18771 894 n=$(($n+1))
pascal@18771 895 done | sh
pascal@18771 896 ls fd???.img
pascal@19878 897 mv fd???.img /mnt
pascal@18771 898 }
pascal@18771 899
pascal@14257 900 fdbootstrap()
pascal@14257 901 {
pascal@18771 902 sz=$((512 * $(echo $(get 26 /mnt/$ISO 1))))
pascal@20771 903 $DIALOG --clear --title " Create a floppy bootstrap " \
pascal@14271 904 --yes-label "Continue" --yesno \
paul@14263 905 "\nThe floppy will install a driver to access the ISO file
pascal@20771 906 on your hard disk and will emulate a CD-ROM during the boot process.\n\n
pascal@20771 907 Please insert a floppy in drive now.\n" 10 70
pascal@14271 908 [ $? -eq 0 ] || return
pascal@17474 909 ddq if=/mnt/$ISO of=/tmp/bootiso bs=1 count=512 \
pascal@17810 910 skip=$(( $(get 64 /mnt/$ISO) - $sz ))
pascal@17474 911 echo "$ISO" | ddq of=/tmp/bootiso bs=512 seek=1 count=1
pascal@17474 912 ddq if=/mnt/$ISO of=/tmp/bootiso bs=1 count=$sz seek=2 \
pascal@17810 913 skip=$(( $(get 64 /mnt/$ISO) - $sz + 512 ))
pascal@17474 914 mkfloppy /tmp/bootiso
pascal@17474 915 rm -f /tmp/bootiso
pascal@14257 916 }
pascal@14257 917
pascal@14257 918 usbdev()
pascal@14257 919 {
pascal@17476 920 dotwait "Wait 5 seconds for USB devices"
pascal@14257 921 sleep 5
pascal@17476 922 rm -f /tmp/wait
pascal@14257 923 DEV="$(grep -l 1 /sys/block/*/removable | \
pascal@14257 924 sed 's|/sys/block/\(.*\)/removable|\1|')"
pascal@17491 925 grep -qs 1 /sys/block/$DEV/ro && return
pascal@17454 926 [ "$DEV" ] || return
pascal@17491 927 cat > /tmp/dialog <<EOT
pascal@20778 928 $DIALOG --clear --title " Select your USB key " \
pascal@14257 929 --menu "\nPlease select the USB key according to its known size.\n\n" \
pascal@14257 930 14 70 4 \
pascal@14257 931 $(for i in $DEV ; do
pascal@17491 932 echo -n "/dev/$i \"$(($(cat /sys/block/$i/size)/2048))MB $(cat /sys/block/$i/device/model 2> /dev/null)\" "
pascal@20762 933 done)
pascal@17491 934 EOT
pascal@17491 935 exec 3>&1
pascal@17491 936 device=$(. /tmp/dialog 2>&1 1>&3)
pascal@14257 937 retval=$?
pascal@14257 938 exec 3>&-
pascal@14257 939 [ $retval -eq 0 ]
pascal@14257 940 }
pascal@14257 941
pascal@17491 942 tazusbmsg()
pascal@17491 943 {
pascal@17491 944 [ "$(which tazusb 2> /dev/null)" ] || return
pascal@17491 945 echo "You should choose 'USB key read/write installation' to be
pascal@17491 946 able to save the package updates or your own configuration and data files.\n\n"
pascal@17491 947 }
pascal@17491 948
pascal@14257 949 usbbootkey()
pascal@14257 950 {
pascal@20771 951 $DIALOG --clear --title " Create a USB boot key " \
pascal@14257 952 --yes-label "Continue" --yesno \
pascal@14257 953 "\nThe USB key will be used like a CD-ROM. You will not be able to write
pascal@17454 954 any data on the boot partition.\n\n
pascal@17454 955 An extra FAT32 partition will be created with the remaining free space.\n\n
pascal@20771 956 $(tazusbmsg)Please plug your USB stick in now.\n" 16 70
pascal@14257 957 [ $? -eq 0 ] || return
pascal@14257 958 usbdev || return
pascal@17454 959
pascal@20762 960 ### perform dd in progress bar
pascal@17491 961 max=$(($(cat /sys/block/loop0/size)/2048))
pascal@20771 962 i=0; ddq if=/mnt/$ISO bs=1024k | (
pascal@20771 963 while ddq bs=1024k count=1 ; do
pascal@17454 964 i=$(($i + 1))
pascal@17454 965 [ $i -gt $max ] && break
pascal@17455 966 echo $((($i*100)/$max)) | dialog --gauge \
pascal@17455 967 " The ISO image transfer can be long. Please wait..." \
pascal@17476 968 6 70 0 > /dev/tty0 2>&1
pascal@17454 969 done ) > $device
pascal@17454 970
pascal@20762 971 ### partition + fat32 format for the remaining space
pascal@17860 972 for p in 0 16; do
pascal@17860 973 get $((450+$p)) $device 2 12 | xargs echo | {
pascal@17860 974 read dx cx ol oh ll lh
pascal@17860 975 [ $dx -eq $((0x3F17)) ] || continue
pascal@17454 976 cx=$(($cx & 0xFF00))
pascal@17454 977 ofs=$(($ll+($lh<<16)))
pascal@17454 978 n=$(($(cat /sys/block/${device#/dev/}/size)-$ofs))
pascal@17454 979 m=$(($cx+($n/8)))
pascal@17454 980 [ $m -gt $((0x3FF00)) ] && m=$((0x3FF00))
pascal@17454 981 m=$((($m & 0xFF00)+(($m>>16)<<6)))
pascal@17454 982 words2bin 0 $((0x101+$cx)) 0x3F0B $((32+$m)) \
pascal@17454 983 $ll $lh $(($n & 0xFFFF)) $(($n >> 16)) | \
pascal@17860 984 ddq bs=1 seek=$((462-$p)) of=$device
pascal@17454 985 if [ "$(which mkdosfs 2> /dev/null)" ]; then
pascal@17562 986 losetup -o $((512*$ofs)) /dev/loop2 $device
pascal@17562 987 mkdosfs -n "SLITAZ BOOT" /dev/loop2
pascal@17454 988 words2bin $(($ofs & 0xFFFF)) $(($ofs >> 16)) | \
pascal@17562 989 ddq bs=1 seek=28 of=/dev/loop2
pascal@17860 990 sync
pascal@17562 991 losetup -d /dev/loop2
pascal@17454 992 fi
pascal@17860 993 }
pascal@17860 994 done
pascal@14257 995 }
pascal@14257 996
pascal@13697 997 usbkey()
pascal@13697 998 {
pascal@20771 999 $DIALOG --clear --title " Create a SliTaz USB key " \
pascal@13697 1000 --yes-label "Continue" --yesno \
pascal@13697 1001 "\nUnlike a hard drive install, the filesystem is kept in a compressed
pascal@13697 1002 rootfs.gz. The filesystem is loaded entirely into memory upon boot.
pascal@13697 1003 This should increase responsiveness, protect the filesystem against
pascal@13697 1004 accidental corruption and reduce read/writes to the USB drive.
pascal@13697 1005 Once setup, the tazusb utility can rewrite the root filesystem
pascal@20771 1006 with any changes you have made since booting up,
pascal@13697 1007 giving the effective benefits of a hard drive install.\n\n
pascal@13697 1008 /home is mounted on boot using the UUID of your particular flash drive.
pascal@13697 1009 Unlike a device name, the UUID has the benefit of never changing from machine
pascal@13697 1010 to machine.\n\n
pascal@20771 1011 Please plug your USB stick in now.\n" 19 70
pascal@14271 1012 [ $? -eq 0 ] || return
pascal@14257 1013 usbdev || return
pascal@13697 1014 exec 3>&1
pascal@20778 1015 format=`$DIALOG --clear --title " Select the filesystem " \
pascal@13733 1016 --radiolist "\nPlease select the filesystem type to create.\n\n\
paul@13698 1017 The filesystem creation will erase all the data \
pascal@13699 1018 in the USB key." 14 70 4 \
pascal@13733 1019 "none" "Do not erase the USB key" on \
pascal@13733 1020 "ext3" "Ext3 journaling filesystem" off \
pascal@13733 1021 "ext2" "Ext2 filesystem" off \
pascal@13733 1022 "fat32" "Windows FAT32 filesystem" off \
pascal@13697 1023 2>&1 1>&3`
pascal@13697 1024 retval=$?
pascal@13697 1025 exec 3>&-
pascal@14257 1026 [ $retval -eq 0 ] || return
pascal@13697 1027 [ "$format" != "none" ] && tazusb format $device "SliTaz" $format
pascal@13697 1028 tazusb gen-iso2usb /mnt/$ISO $device
pascal@13697 1029 }
pascal@13697 1030
pascal@13713 1031 mount_loram()
pascal@13713 1032 {
pascal@13713 1033 is_loram || return
pascal@21459 1034 insmod /lib/modules/squashfs.ko* 2> /dev/null
pascal@13713 1035 if [ -d /media/cdrom/fs ]; then
pascal@13713 1036 ln -s /media/cdrom/fs /sqfs
pascal@13713 1037 else
pascal@13713 1038 mkdir /sqfs
pascal@13713 1039 mount -o loop,ro -t squashfs /rootfs*.gz /sqfs
pascal@13713 1040 fi
pascal@13713 1041 ln -s /sqfs/lib/* lib
pascal@21386 1042 ln -fs /sqfs/usr /sqfs/var /
pascal@13713 1043 }
pascal@13713 1044
pascal@13713 1045 umount_loram()
pascal@13713 1046 {
pascal@13713 1047 is_loram || return
pascal@20778 1048 rm /var /usr
pascal@13713 1049 umount -d /sqfs
pascal@21377 1050 rmdir /sqfs 2> /dev/null || rm -f /sqfs
pascal@13713 1051 }
pascal@13713 1052
pascal@17569 1053 dosync()
pascal@13691 1054 {
pascal@17569 1055 sync
pascal@13713 1056 umount_loram
pascal@13691 1057 umount -d /media/cdrom
pascal@16073 1058 rm -f /dev/cdrom
pascal@13691 1059 umount /mnt
pascal@16041 1060 umount_proc
pascal@17569 1061 }
pascal@17569 1062
pascal@17569 1063 text()
pascal@17569 1064 {
pascal@18774 1065 init=
pascal@18774 1066 cmdline="$(cat /proc/cmdline)"
pascal@18774 1067 if hascustomconf; then
pascal@18774 1068 getcustomconf /tmp > /dev/null
pascal@18774 1069 [ -s /tmp/cmdline ] &&
pascal@18774 1070 cmdline="$cmdline $(cat /tmp/cmdline)" &&
pascal@18774 1071 init="$(sed '/rdinit=/!d;s/.*rdinit=\([^ ]*\).*/\1/' < /tmp/cmdline)"
pascal@18774 1072 [ -s /tmp/initrd ] && uncpio /tmp/initrd
pascal@18774 1073 fi
pascal@17569 1074 dosync
pascal@18774 1075 exec ${init:-/init} $cmdline
pascal@13691 1076 }
pascal@13691 1077
pascal@13691 1078 live()
pascal@13691 1079 {
pascal@13691 1080 n=0
pascal@17476 1081 dotwait "Extract filesystem..."
pascal@17562 1082 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@17562 1083 grep -q ' lm ' /proc/cpuinfo && [ -s ${i}64 ] && i=${i}64
pascal@13691 1084 [ $((n++)) -eq 0 ] || uncpio $i
pascal@13691 1085 done
pascal@17476 1086 rm -f /tmp/wait
pascal@13691 1087 text
pascal@13691 1088 }
pascal@13691 1089
pascal@13713 1090 restart()
pascal@13691 1091 {
pascal@17476 1092 dosync
pascal@13713 1093 reboot -f
pascal@13691 1094 }
pascal@13691 1095
pascal@13713 1096 stop()
pascal@13691 1097 {
pascal@17476 1098 dosync
pascal@13713 1099 poweroff -f
pascal@13691 1100 }
pascal@13691 1101
pascal@17489 1102 dokexec()
pascal@17476 1103 {
pascal@17659 1104 kexec -l $file || return
pascal@17476 1105 dosync
pascal@17476 1106 kexec -e
pascal@17476 1107 }
pascal@17476 1108
pascal@17489 1109 runmemtest()
pascal@17489 1110 {
pascal@17635 1111 gotcdfile "memtest*" && dokexec
pascal@17489 1112 }
pascal@17489 1113
pascal@17476 1114 runpxe()
pascal@17476 1115 {
pascal@20762 1116 gotcdfile "?pxe*" && dokexec
pascal@17476 1117 }
pascal@17476 1118
pascal@17931 1119 flavdata()
pascal@17931 1120 {
pascal@20762 1121 [ $(get 1024 /mnt/$ISO) -eq 35615 ] && n=2 ||
pascal@20762 1122 n=$((1+$(get 417 /mnt/$ISO 1)))
pascal@20762 1123 [ $n -eq 4 ] && n=20
pascal@20762 1124 [ $(get $(($n*512)) /mnt/$ISO) -eq 35615 ] || n=13
pascal@20762 1125 ddq if=/mnt/$ISO bs=512 skip=$n count=20 | zcat 2>/dev/null
pascal@17931 1126 }
pascal@17931 1127
pascal@17931 1128 hasflavinfo()
pascal@17931 1129 {
pascal@20891 1130 [ "$(flavdata | ddq bs=1 count=7)" = "0707010" ] &&
pascal@19510 1131 echo -en "\"$1\" \"$2\""
pascal@17931 1132 }
pascal@17931 1133
pascal@17931 1134 showfavinfo()
pascal@17931 1135 {
pascal@17931 1136 mkdir -p /tmp/data
pascal@17931 1137 flavdata | ( cd /tmp/data ; cpio -i )
pascal@17931 1138 file=/tmp/data/info
pascal@17931 1139 cat /tmp/data/*desc > $file
pascal@17931 1140 for i in /tmp/data/*list* ; do
pascal@17931 1141 echo "=== extra ${i#*list} files"
pascal@17931 1142 cat $i
pascal@17931 1143 done >> $file
pascal@20771 1144 $DIALOG --clear --title " Flavor info " --textbox $file 24 78
pascal@17931 1145 rm -rf /tmp/data
pascal@17931 1146 }
pascal@17931 1147
pascal@18771 1148 flavor()
pascal@18771 1149 {
pascal@18771 1150 cd /mnt
pascal@18771 1151 name="$(flavdata | cpio -t 2> /dev/null | sed 's/.[a-z]*$//;q')"
pascal@18771 1152 echo "Create ${name:=flavor}.flavor..."
pascal@18771 1153 tazlito iso2flavor "/mnt/$ISO" $name
pascal@18771 1154 ls -l $name.flavor 2> /dev/null || sleep 5
pascal@18771 1155 cd - > /dev/null
pascal@18771 1156 }
pascal@18771 1157
pascal@13697 1158 shell()
pascal@13697 1159 {
pascal@20771 1160 trap text 2
pascal@21459 1161 getty -n -l /bin/ash 38400 tty1 2> /dev/null || sh
pascal@13697 1162 }
pascal@13697 1163
pascal@14247 1164 BIN=bin/mount.posixovl
pascal@14247 1165 [ -x /usr/s$BIN ] || mv /bin/mount.posixovl.iso2exe \
pascal@17489 1166 /usr/s$BIN 2> /dev/null || mv /bin/mount.posixovl.iso2exe /$BIN 2> /dev/null
pascal@16041 1167 mount_proc
pascal@18804 1168 for i in /sys/block/*/dev /sys/block/*/*/dev ; do
pascal@18804 1169 [ -s "$i" ] || continue
pascal@18804 1170 n=${i%/dev}
pascal@18804 1171 n=/dev/${n##*/}
pascal@18804 1172 [ -e $n ] && continue
pascal@18804 1173 mknod $n b $(sed 's/:/ /' < $i)
pascal@18804 1174 done
pascal@17489 1175 ISO="$(getarg bootfrom | sed 's/.://;s|\\|/|g')"
pascal@19510 1176 getiso || text 2> /dev/null
pascal@13713 1177 mount_loram
pascal@16041 1178 case "${ISO##*/}$(getarg mode)" in
pascal@16047 1179 *install*|*INSTALL*) install ;;
pascal@16047 1180 *live*|*LIVE*) live ;;
pascal@16047 1181 *text*|*TEXT*) text ;;
pascal@13691 1182 esac
pascal@17489 1183 which $DIALOG 2> /dev/null || DIALOG=tinydialog
pascal@13713 1184 dmesg > /tmp/dmesg
pascal@13691 1185
pascal@18778 1186 isotitle="$(blkid /mnt/$ISO | sed 's/.*LABEL="\([^"]*\).*/\1/') $(stat \
pascal@18778 1187 -c %y /media/cdrom | sed 's/ .*//') $(basename $ISO)"
pascal@13691 1188 while true; do
pascal@20771 1189 trap shell 2
pascal@16055 1190 keymap="$(cat /etc/keymap.conf 2> /dev/null)"
pascal@16055 1191 locale="$(sed '/^LANG=/!d;s/.*=//' /etc/locale.conf 2> /dev/null)"
pascal@14271 1192 cat > /tmp/dialog <<EOT
pascal@20778 1193 $DIALOG --clear --title " ${isotitle:-Welcome to Linux} " \
pascal@17454 1194 --menu "" 23 70 17 \
pascal@17489 1195 $(xfile tazkeymap "tazkeymap" "Select keyboard (${keymap:-none})") \
pascal@17489 1196 $(xfile tazlocale "tazlocale" "Select locale (${locale:-none})") \
pascal@17489 1197 $(cdfile boot/bzImage "live" "Linux RAM boot (full desktop)") \
pascal@17489 1198 "text" "Linux RAM boot" \
pascal@17635 1199 $(cdfile "README*" "readme" "Show the README file") \
pascal@18771 1200 $(gotcustomconf "getcustomconf" "Get custom config") \
pascal@17492 1201 $(gotisomd5 "isomd5" "Check the ISO image") \
pascal@17635 1202 $(cdfile "md5sum*" "md5" "Check the ISO files") \
pascal@17635 1203 $(cdfile "sha*sum*" "sha" "Check the ISO files") \
pascal@18034 1204 $(burnable "burniso" "Burn the ISO image") \
pascal@18034 1205 $(blankable "blankcd" "Blank the CD/DVD") \
pascal@16041 1206 $(gotposixovl "install" "Hard disk installation (UMSDOS way)") \
pascal@16041 1207 $(gotposixovl "installtaz" "Hard disk installation (TAZUSB way)") \
pascal@14271 1208 $(xfile tazusb "usbkey" "USB key read/write installation") \
pascal@17491 1209 $(ishybrid "usbbootkey" "USB boot key (read only)") \
paul@17935 1210 $(hasflavinfo "showfavinfo" "Show flavor extra info") \
pascal@18771 1211 $(xfile tazlito "flavor" "Get flavor file") \
pascal@17476 1212 $(fddata "fdbootstrap" "Create a floppy bootstrap") \
pascal@18771 1213 $(cdfile isolinux.cfg "floppyset" "Boot floppy set") \
pascal@17491 1214 "tazboot" "Get tazboot.exe Linux loader" \
pascal@17476 1215 $(cdexe boot/bzImage "bzimage" "Get linux DOS/EXE file") \
pascal@17635 1216 $(cdexe "memtest*" "memtest" "Get Memtest86 DOS/EXE file") \
pascal@17635 1217 $(cdfilef "memtest*" "fdmemtest" "Create a Memtest86 boot floppy") \
pascal@18771 1218 $(:||cdfilex "memtest*" "runmemtest" "Start Memtest86") \
pascal@20762 1219 $(cdexe "?pxe*" "pxe" "Get SliTaz Web boot DOS/EXE utility") \
pascal@20762 1220 $(cdfilef "?pxe*" "fdpxe" "Create a SliTaz Web boot floppy") \
pascal@20762 1221 $(:||cdfilex "?pxe*" "runpxe" "Start the SliTaz Web boot utility") \
pascal@14271 1222 $(xfile reboot "restart" "Restart the computer") \
pascal@14271 1223 $(xfile poweroff "stop" "Power off") \
pascal@13697 1224 "bootlog" "Linux boot messages" \
pascal@20762 1225 "shell" "Shell prompt"
pascal@14271 1226 EOT
pascal@14271 1227 exec 3>&1
pascal@17489 1228 value=$(. /tmp/dialog 2>&1 1>&3)
pascal@13691 1229 retval=$?
pascal@13691 1230 exec 3>&-
pascal@13691 1231 [ $retval -eq 0 ] || continue
pascal@13691 1232 $value
pascal@13691 1233 done